{% extends "base.html" %}
{% block head_base %}
<base href="/" />
{% endblock %}
{% block stylesheets %}
<link rel="stylesheet" type="text/css" href="/static/docs/swagger-ui.css" />
<link
    rel="stylesheet"
    type="text/css"
    href="/static/fa/css/all.min.css"
/>
<style>
    .topbar {
        display: none !important;
    }
    .theme-toggle-wrapper {
        position: fixed;
        top: 0;
        right: 0;
        z-index: 1000;
        padding: 10px;
    }
    .theme-toggle-button {
        background: none;
        border: none;
        cursor: pointer;
        outline: none;
        display: flex;
    }
    .theme-toggle-button i {
        cursor: pointer;
        font-size: 1.5rem;
    }
</style>
{% endblock %} {% block body %}
<div class="theme-toggle-wrapper" id="theme-toggle-wrapper">
    <button
        id="theme-toggle"
        class="theme-toggle-button"
        onclick="_toggleTheme()"
    >
        <i class="fa fa-sun" id="dark-mode-icon" style="display: none"></i>
        <i class="fa fa-moon" id="light-mode-icon"></i>
    </button>
</div>
<div id="swagger-ui"></div>
{% endblock %} {% block body_js %}
<script src="/static/docs/swagger-ui-bundle.js"></script>
<script src="/static/docs/swagger-ui-standalone-preset.js"></script>
<script>
    function _addDarkStylesheet() {
        _removeDarkStylesheet(); // to avoid duplicates
        const link = document.createElement("link");
        link.id = "swagger-dark-stylesheet";
        link.rel = "stylesheet";
        link.href = "/static/docs/swagger-dark.css";
        document.head.appendChild(link);
    }
    function _removeDarkStylesheet() {
        const darkStylesheet = document.getElementById(
            "swagger-dark-stylesheet"
        );
        if (darkStylesheet) {
            darkStylesheet.remove();
        }
    }
    function _toggleTheme() {
        isDarkMode() ? _removeDarkStylesheet() : _addDarkStylesheet();
        toggleTheme();
    }

    const uiInitialized = () => {
      try {
        ui;
        return true;
      } catch {
        return false;
      }
    };

    const isSchemaUrl = (url) => {
      if (!uiInitialized()) {
        return false;
      }
      return url === new URL(ui.getConfigs().url, document.baseURI).href;
    };
    ready(function () {
        const useDarkTheme = isDarkMode();
        if (useDarkTheme) {
            _addDarkStylesheet();
        }
        const ui = SwaggerUIBundle({
            url: "{{ schema_url }}",
            dom_id: "#swagger-ui",
            presets: [SwaggerUIBundle.presets.apis, SwaggerUIStandalonePreset],
            deepLinking: true,
            persistAuthorization: true,
            layout: "StandaloneLayout",
            plugins: [
                SwaggerUIBundle.plugins.DownloadUrl,
                SwaggerUIBundle.plugins.TopbarPlugin,
                SwaggerUIBundle.plugins.StandaloneLayoutPlugin,
            ],
            syntaxHighlight: {
                activate: true,
                theme: "agate",
            },
            validatorUrl: null,
            tagSorter: "alpha",
            operationsSorter: "alpha",
            defaultModelRendering: "example",
        });
        window.ui = ui;
    });
</script>
{% endblock %}
